VERSION 5.00
Object = "{831FDD16-0C5C-11D2-A9FC-0000F8754DA1}#2.0#0"; "MSCOMCTL.OCX"
Begin VB.Form fMain 
   Caption         =   "Export TypeLib"
   ClientHeight    =   10365
   ClientLeft      =   60
   ClientTop       =   450
   ClientWidth     =   10890
   LinkTopic       =   "Form1"
   ScaleHeight     =   10365
   ScaleWidth      =   10890
   StartUpPosition =   2  'CenterScreen
   Begin MSComctlLib.TreeView twTLI 
      Height          =   10275
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   10755
      _ExtentX        =   18971
      _ExtentY        =   18124
      _Version        =   393217
      LineStyle       =   1
      Style           =   7
      Appearance      =   1
   End
End
Attribute VB_Name = "fMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private TV As TreeView
Private TLI_Name As String

Private Sub Form_Load()
  Dim x As Long
  
  Dim tTLInfo  As TypeLibInfo
  
  Dim tTypeInfo As TypeInfo
  Dim tMember As MemberInfo
  Dim tInterface As InterfaceInfo
  Dim tIInterface As InterfaceInfo
  
  TLI_Name = "d:\Windows\system32\shell32.dll"
  'TLI_Name = "C:\MrReset\On Work\MrReset VB FrameWork\RedInst\DLL\MrHRT.dll"

  Set TV = fMain.twTLI
  EnumTypeLibInfo TLI.TLIApplication.TypeLibInfoFromFile(TLI_Name), 10
  fMain.Caption = fMain.Caption & " - " & TLI_Name
End Sub

Public Function EnumTypeLibInfo(ByRef pTypeLibInfo As TypeLibInfo, ByVal RecurseLvl As Long)
  'On Local Error Resume Next
  Dim NewNode As MSComctlLib.Node
  Dim NewNode2 As MSComctlLib.Node
  Dim pCustomData As CustomData
  TV.Nodes.Clear
  Set NewNode = TV.Nodes.Add(, , NewKey, pTypeLibInfo.Name)
  Set NewNode.Tag = pTypeLibInfo.TypeInfos
  
    For Each pCustomData In pTypeLibInfo.CustomDataCollection
      Set NewNode2 = TV.Nodes.Add(NewNode.Key, tvwChild, NewKey, pCustomData.Guid + " = " + CStr(pCustomData.Value))
      Set NewNode2.Tag = pCustomData
      'NewNode.EnsureVisible
      'ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next
    
  'NewNode.EnsureVisible
  ExpandTypeInfos NewNode, RecurseLvl - 1

  'On Local Error GoTo 0
End Function

Public Sub ExpandTypeInfos(ByRef Node As MSComctlLib.Node, ByVal RecurseLvl As Long)
  'On Local Error Resume Next
  Dim NewNode As MSComctlLib.Node
  Dim pTypeInfo As TypeInfo
  If RecurseLvl <= 0 Then Exit Sub
  If TypeOf Node.Tag Is TypeInfos Then
    For Each pTypeInfo In Node.Tag
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pTypeInfo.Name + " " + pTypeInfo.Guid)
      Set NewNode.Tag = pTypeInfo
      'NewNode.EnsureVisible
      ExpandTypeInfo NewNode, RecurseLvl - 1
    Next
  End If
  'On Local Error GoTo 0
End Sub


Public Sub ExpandTypeInfo(ByRef Node As MSComctlLib.Node, ByVal RecurseLvl As Long)
  On Local Error Resume Next
  Dim NewNode As MSComctlLib.Node
  Dim pInterfaceInfo As InterfaceInfo
  If RecurseLvl <= 0 Then Exit Sub
  If TypeOf Node.Tag Is TypeInfo Then
    For Each pInterfaceInfo In Node.Tag.ImpliedInterfaces
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
      Set NewNode.Tag = pInterfaceInfo
      'NewNode.EnsureVisible
      ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next
    
    Set pInterfaceInfo = Node.Tag.DefaultInterface
    Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
    Set NewNode.Tag = pInterfaceInfo
    'NewNode.EnsureVisible
    ExpandInterfaceInfo NewNode, RecurseLvl - 1
    
    Set pInterfaceInfo = Node.Tag.DefaultEventInterface
    Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
    Set NewNode.Tag = pInterfaceInfo
    'NewNode.EnsureVisible
    ExpandInterfaceInfo NewNode, RecurseLvl - 1
    
    For Each pInterfaceInfo In Node.Tag.Interfaces
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
      Set NewNode.Tag = pInterfaceInfo
      'NewNode.EnsureVisible
      ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next
    
    Set pInterfaceInfo = Node.Tag.VTableInterface
    Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
    Set NewNode.Tag = pInterfaceInfo
    'NewNode.EnsureVisible
    ExpandInterfaceInfo NewNode, RecurseLvl - 1

  End If
  On Local Error GoTo 0
End Sub
Public Sub ExpandInterfaceInfo(ByRef Node As MSComctlLib.Node, ByVal RecurseLvl As Long)
  On Local Error Resume Next
  Dim NewNode As MSComctlLib.Node
  Dim pInterfaceInfo As InterfaceInfo
  Dim pMember As MemberInfo
  Dim pCustomData As CustomData
  
  If RecurseLvl <= 0 Then Exit Sub
  If TypeOf Node.Tag Is TypeInfo Then
    For Each pInterfaceInfo In Node.Tag.ImpliedInterfaces
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
      Set NewNode.Tag = pInterfaceInfo
      'NewNode.EnsureVisible
      ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next
    For Each pInterfaceInfo In Node.Tag.Interfaces
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pInterfaceInfo.TypeKindString + " " + pInterfaceInfo.Name + " " + pInterfaceInfo.Guid)
      Set NewNode.Tag = pInterfaceInfo
      'NewNode.EnsureVisible
      ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next
    For Each pMember In Node.Tag.Members
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, InvokeInfo(pMember.InvokeKind) + " " + pMember.Name + " " + CStr(pMember.VTableOffset))
      Set NewNode.Tag = pMember
      'NewNode.EnsureVisible
      ExpandMemberInfo NewNode, RecurseLvl - 1
    Next
    
    For Each pCustomData In Node.Tag.CustomDataCollection
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pCustomData.Guid + " = " + CStr(pCustomData.Value))
      Set NewNode.Tag = pCustomData
      'NewNode.EnsureVisible
      'ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next

  End If
  On Local Error GoTo 0
End Sub

Public Sub ExpandMemberInfo(ByRef Node As MSComctlLib.Node, ByVal RecurseLvl As Long)
  'On Local Error Resume Next
  Dim NewNode As MSComctlLib.Node
  Dim NewNode2 As MSComctlLib.Node
  Dim pMember As MemberInfo
  Dim pParameter As ParameterInfo
  Dim pCustomData As CustomData
  
  If RecurseLvl <= 0 Then Exit Sub
  If TypeOf Node.Tag Is MemberInfo Then
    For Each pParameter In Node.Tag.Parameters
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pParameter.VarTypeInfo + " " + pParameter.Name + " = " + pParameter.DefaultValue)
      Set NewNode.Tag = pParameter
      'NewNode.EnsureVisible
      'ExpandInterfaceInfo NewNode, RecurseLvl - 1
      If pParameter.HasCustomData Then
        For Each pCustomData In pParameter.CustomDataCollection
          Set NewNode2 = TV.Nodes.Add(NewNode.Key, tvwChild, NewKey, pCustomData.Guid + " = " + CStr(pCustomData.Value))
          Set NewNode2.Tag = pCustomData
          'NewNode.EnsureVisible
          'ExpandInterfaceInfo NewNode, RecurseLvl - 1
        Next
      End If
    Next
    
    For Each pCustomData In Node.Tag.CustomDataCollection
      Set NewNode = TV.Nodes.Add(Node.Key, tvwChild, NewKey, pCustomData.Guid + " = " + CStr(pCustomData.Value))
      Set NewNode.Tag = pCustomData
      'NewNode.EnsureVisible
      'ExpandInterfaceInfo NewNode, RecurseLvl - 1
    Next

  End If
  'On Local Error GoTo 0
End Sub


Private Function NewKey() As String
  Static Key As Long
  Key = Key + 1
  NewKey = "K" + CStr(Key + 1)
End Function

Function InvokeInfo(ByVal InvKinds As TLI.InvokeKinds) As String
  If InvKinds And INVOKE_CONST Then
    InvokeInfo = "Constant"
    Exit Function
  End If
  Select Case InvKinds
    Case INVOKE_EVENTFUNC
      InvokeInfo = "Event"
    Case INVOKE_FUNC
      InvokeInfo = "Method"
    Case INVOKE_PROPERTYGET
      InvokeInfo = "Property Get"
    Case INVOKE_PROPERTYPUT
      InvokeInfo = "Property Let"
    Case INVOKE_PROPERTYPUTREF
      InvokeInfo = "Property Set"
    Case INVOKE_PROPERTYPUT Or INVOKE_PROPERTYGET
      InvokeInfo = "Property Get/Let"
    Case INVOKE_PROPERTYPUTREF Or INVOKE_PROPERTYGET
      InvokeInfo = "Property Get/Set"
    Case INVOKE_PROPERTYPUTREF Or INVOKE_PROPERTYPUT
      InvokeInfo = "Property Let/Set"
    Case INVOKE_PROPERTYGET Or INVOKE_PROPERTYPUTREF Or INVOKE_PROPERTYPUT
      InvokeInfo = "Property Get/Let/Set"
  End Select
End Function
Function TypeInfo(ByVal TyKinds As TLI.TypeKinds) As String
  Select Case TyKinds
    Case TKIND_ALIAS
      TypeInfo = "ALIAS"
    Case TKIND_COCLASS
      TypeInfo = "COCLASS"
    Case TKIND_DISPATCH
      TypeInfo = "DISPATCH"
    Case TKIND_ENUM
      TypeInfo = "ENUM"
    Case TKIND_INTERFACE
      TypeInfo = "INTERFACE"
    Case TKIND_MAX
      TypeInfo = "MAX"
    Case TKIND_MODULE
      TypeInfo = "MODULE"
    Case TKIND_RECORD
      TypeInfo = "RECORD"
    Case TKIND_UNION
      TypeInfo = "UNION"
    Case Else
      TypeInfo = ""
  End Select
End Function


